Attribute VB_Name = "modIniFiles"
Option Explicit

Public Function fGetIniItem(ByVal sSection As String, ByVal sItem As String, ByVal sIniFile As String) As String
  Dim sLine As String, sLastKey As String
  Dim FileNr As Integer

  FileNr = FreeFile
  Open sIniFile For Input As #FileNr
    Do While Not EOF(FileNr)
      Line Input #1, sLine
      If Len(sLine) > 0 And Mid$(sLine, 1, 1) = "[" Then
        sLastKey = Right(Left(sLine, Len(sLine) - 1), Len(sLine) - 2)
      Else
        If Len(sLine) > 0 And sLastKey = sSection Then
          If fGetItemName(sLine) = sItem Then
            If fGetItemValue(sLine) <> "" Then fGetIniItem = fGetItemValue(sLine)
          End If
        End If
      End If
    Loop
  Close #FileNr
End Function

Public Sub fSetIniItem(ByVal sSection As String, ByVal sItem As String, ByVal sNewValue As String, ByVal sIniFile As String)
  Dim sTemp As String, sLine As String, sLastKey As String
  Dim FileNr As Integer

  sTemp = ""

  FileNr = FreeFile
  Open sIniFile For Input As #FileNr
    Do While Not EOF(FileNr)
      Line Input #FileNr, sLine
      If Len(sLine) > 0 And Mid$(sLine, 1, 1) = "[" Then
        sLastKey = Right(Left(sLine, Len(sLine) - 1), Len(sLine) - 2)
        sTemp = sTemp & sLine & vbNewLine
      Else
        If Len(sLine) > 0 And sLastKey = sSection Then
          If fGetItemName(sLine) = sItem Then
            sTemp = sTemp & fGetItemName(sLine) & "=" & sNewValue & vbNewLine
          Else
            sTemp = sTemp & sLine & vbNewLine
          End If
        Else
          sTemp = sTemp & sLine & vbNewLine
        End If
      End If
    Loop
  Close #FileNr

  Do While Right(sTemp, 1) = vbCr Or Right(sTemp, 1) = vbLf
    sTemp = Mid(sTemp, 1, Len(sTemp) - 1)
  Loop

  FileNr = FreeFile
  Open sIniFile For Output As #FileNr
    Print #FileNr, sTemp
  Close #FileNr
End Sub

Public Function fGetIniTextSection(ByVal sSection As String, ByVal sIniFile As String) As String
  Dim sTemp As String, sLine As String, sLastKey As String
  Dim FileNr As Integer
  sTemp = ""

  FileNr = FreeFile
  Open sIniFile For Input As #FileNr
    Do While Not EOF(FileNr)
      Line Input #FileNr, sLine
      If Len(sLine) > 0 And Mid$(sLine, 1, 1) = "[" Then
        sLastKey = Right(Left(sLine, Len(sLine) - 1), Len(sLine) - 2)
      Else
        If sLastKey = sSection And Mid$(sLine, 1, 1) <> ";" Then
          sTemp = sTemp & sLine & vbNewLine
        End If
      End If
    Loop
  Close #FileNr

  Do While Right(sTemp, 1) = vbCr Or Right(sTemp, 1) = vbLf
    sTemp = Mid(sTemp, 1, Len(sTemp) - 1)
  Loop

  fGetIniTextSection = sTemp & vbNewLine
End Function

Public Function fGetIniTextItemSection(ByVal sSection As String, ByVal sIniFile As String) As String()
  Dim aTemp() As String
  Dim sLine As String, sLastKey As String, sLineCount As Long
  Dim FileNr As Integer

  sLineCount = 0

  FileNr = FreeFile
  Open sIniFile For Input As #FileNr
    Do While Not EOF(FileNr)
      Line Input #FileNr, sLine
      If Len(sLine) > 0 And Mid$(sLine, 1, 1) = "[" Then
        sLastKey = Right(Left(sLine, Len(sLine) - 1), Len(sLine) - 2)
      Else
        If Len(sLine) > 0 And sLastKey = sSection Then
          If Mid$(sLine, 1, 1) <> ";" Then
            ReDim Preserve aTemp(0 To sLineCount) As String
            aTemp(sLineCount) = sLine
            sLineCount = sLineCount + 1
          End If
        End If
      End If
    Loop
  Close #FileNr
  fGetIniTextItemSection = aTemp
End Function

Private Function fGetItemName(sItem As String) As String
  Dim nPos As Integer
  nPos = InStr(1, sItem, "=")
  fGetItemName = Left(sItem, nPos - 1)
End Function

Private Function fGetItemValue(sItem As String) As String
  Dim nPos As Integer
  nPos = InStr(sItem, "=")
  fGetItemValue = Right(sItem, Len(sItem) - nPos)
End Function

